diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_squit.c ircd-hybrid-fuis/modules/m_squit.c
--- ircd-hybrid-7.0rc9/modules/m_squit.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-fuis/modules/m_squit.c	Wed Mar 12 16:24:46 2003
@@ -0,0 +1,235 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_squit.c: Makes a server quit.
+ *
+ *  Copyright (C) 2002 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_squit.c,v 1.47 2003/02/14 23:01:53 db Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"      /* FALSE bleah */
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+
+static void ms_squit(struct Client*, struct Client*, int, char**);
+static void mo_squit(struct Client*, struct Client*, int, char**);
+
+struct Message squit_msgtab = {
+  "SQUIT", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_not_oper, ms_squit, mo_squit}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&squit_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&squit_msgtab);
+}
+const char *_version = "$Revision: 1.47 $";
+#endif
+struct squit_parms 
+{
+  char *server_name;
+  struct Client *target_p;
+};
+
+static struct squit_parms *find_squit(struct Client *client_p,
+                                      struct Client *source_p,
+                                      char *server);
+
+
+/*
+ * mo_squit - SQUIT message handler
+ *      parv[0] = sender prefix
+ *      parv[1] = server name
+ *      parv[2] = comment
+ */
+static void mo_squit(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  struct squit_parms *found_squit;
+  char  *comment = (parc > 2 && parv[2]) ? parv[2] : client_p->name;
+
+  if (!IsOperRemote(source_p))
+    {
+      sendto_one(source_p,":%s NOTICE %s :You need remote = yes;",me.name,parv[0]);
+      return;
+    }
+
+  if(parc < 2)
+    {
+      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, parv[0], "SQUIT");
+      return;
+    }
+
+  if( (found_squit = find_squit(client_p,source_p,parv[1])) )
+    {
+      if(MyConnect(found_squit->target_p))
+	{
+	  sendto_realops_flags(FLAGS_ALL, L_ALL,
+			       "Received SQUIT %s from %s (%s)",
+			       found_squit->target_p->name,
+			       get_client_name(source_p, HIDE_IP), comment);
+          ilog(L_NOTICE, "Received SQUIT %s from %s (%s)",
+	       found_squit->target_p->name, get_client_name(source_p, HIDE_IP),
+	       comment);
+	}
+      exit_client(client_p, found_squit->target_p, source_p, comment);
+      return;
+    }
+  else
+    {
+	    sendto_one(source_p, form_str(ERR_NOSUCHSERVER),
+		       me.name, parv[0], parv[1]);
+    }
+}
+
+/*
+ * ms_squit - SQUIT message handler
+ *      parv[0] = sender prefix
+ *      parv[1] = server name
+ *      parv[2] = comment
+ */
+static void ms_squit(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  struct squit_parms *found_squit;
+  char  *comment = (parc > 2 && parv[2]) ? parv[2] : client_p->name;
+
+  if(parc < 2)
+  {
+    exit_client(client_p, client_p, source_p, comment);
+    return;
+  }
+
+  if((found_squit = find_squit(client_p, source_p, parv[1])))
+  {
+    /*
+    **  Notify all opers, if my local link is remotely squitted
+    */
+    if (MyConnect(found_squit->target_p))
+    {
+      sendto_wallops_flags(FLAGS_WALLOP, &me,
+			   "Remote SQUIT %s from %s (%s)",
+			   found_squit->server_name,
+			   source_p->name, comment);
+      
+      sendto_server(NULL, NULL, NULL, NOCAPS, NOCAPS, NOFLAGS,
+		    ":%s WALLOPS :Remote SQUIT %s from %s (%s)",
+		    me.name, found_squit->server_name,
+		    source_p->name, comment);
+
+      ilog(L_TRACE, "SQUIT From %s : %s (%s)", parv[0],
+	   found_squit->server_name, comment);
+
+    }
+    exit_client(client_p, found_squit->target_p, source_p, comment);
+    return;
+  }
+}
+
+
+/*
+ * find_squit
+ * inputs	- local server connection
+ *		-
+ *		-
+ * output	- pointer to struct containing found squit or none if not found
+ * side effects	-
+ */
+static struct squit_parms *
+find_squit(struct Client *client_p, struct Client *source_p, char *server)
+{
+  static struct squit_parms found_squit;
+  static struct Client *target_p;
+  struct ConfItem *aconf;
+
+  found_squit.target_p = NULL;
+  found_squit.server_name = NULL;
+
+  /*
+  ** To accomodate host masking, a squit for a masked server
+  ** name is expanded if the incoming mask is the same as
+  ** the server name for that link to the name of link.
+  */
+  if ((*server == '*') && IsServer(client_p))
+    {
+      aconf = client_p->serv->sconf;
+      if (aconf)
+        {
+	  if (!irccmp(server, my_name_for_link(me.name, aconf)))
+	    {
+	       found_squit.server_name = client_p->name;
+	       found_squit.target_p = client_p;
+	    }
+	}
+    }
+
+  /*
+  ** The following allows wild cards in SQUIT. Only useful
+  ** when the command is issued by an oper.
+  */
+  for (target_p = GlobalClientList; (target_p = next_client(target_p, server));
+       target_p = target_p->next)
+    {
+      if (IsServer(target_p) || IsMe(target_p))
+	break;
+    }
+
+  found_squit.target_p = target_p;
+  found_squit.server_name = server;
+
+  if (target_p && IsMe(target_p))
+    {
+       if (IsClient(client_p))
+         {
+		 sendto_one(source_p,":%s NOTICE %s :You are trying to squit me.",me.name,client_p->name);
+	         found_squit.target_p = NULL;
+         }
+       else
+         {
+           found_squit.target_p = client_p;
+           found_squit.server_name = client_p->name;
+         }
+       
+    }
+
+  if(found_squit.target_p != NULL)
+    return &found_squit;
+  else
+    return(NULL);
+}
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_stats.c ircd-hybrid-fuis/modules/m_stats.c
--- ircd-hybrid-7.0rc9/modules/m_stats.c	Fri Jan 17 08:00:50 2003
+++ ircd-hybrid-fuis/modules/m_stats.c	Sun Feb 16 21:09:37 2003
@@ -31,7 +31,6 @@
 #include "irc_string.h"  
 #include "ircd.h"        /* me */
 #include "listener.h"    /* show_ports */
-#include "s_gline.h"
 #include "ircd_handler.h"
 #include "msg.h"         /* Message */
 #include "hostmask.h"  /* report_mtrie_conf_links */
@@ -67,16 +66,12 @@
 void
 _modinit(void)
 {
-  hook_add_event("doing_stats");
-  hook_add_event("doing_stats_p");
   mod_add_cmd(&stats_msgtab);
 }
 
 void
 _moddeinit(void)
 {
-  hook_del_event("doing_stats_p");
-  hook_del_event("doing_stats");
   mod_del_cmd(&stats_msgtab);
 }
 
@@ -91,8 +86,6 @@
 static void stats_L_list(struct Client *s, char *, int, int,
                          dlink_list *, char);
 static void stats_spy(struct Client *, char);
-static void stats_p_spy(struct Client *);
-static void stats_L_spy(struct Client *, char, char *);
 
 /* Heres our struct for the stats table */
 struct StatsStruct
@@ -108,8 +101,6 @@
 static void stats_deny(struct Client *);
 static void stats_exempt(struct Client *);
 static void stats_events(struct Client *);
-static void stats_pending_glines(struct Client *);
-static void stats_glines(struct Client *);
 static void stats_hubleaf(struct Client *);
 static void stats_auth(struct Client *);
 static void stats_tklines(struct Client *);
@@ -147,8 +138,6 @@
   { 'E',	stats_events,		1,	1,	},
   { 'f',	fd_dump,		1,	1,	},
   { 'F',	fd_dump,		1,	1,	},
-  { 'g',	stats_pending_glines,	1,	0,	},
-  { 'G',	stats_glines,		1,	0,	},
   { 'h',	stats_hubleaf,		1,	0,	},
   { 'H',	stats_hubleaf,		1,	0,	},
   { 'i',	stats_auth,		0,	0,	},
@@ -244,8 +233,7 @@
   /* Send the end of stats notice, and the stats_spy */
   sendto_one(source_p, form_str(RPL_ENDOFSTATS), me.name, parv[0], parv[1]);
 
-  if((statchar != 'L') && (statchar != 'l'))
-    stats_spy(source_p, statchar);
+  stats_spy(source_p, statchar);
 }
 
 /*
@@ -295,8 +283,7 @@
   /* Send the end of stats notice, and the stats_spy */
   sendto_one(source_p, form_str(RPL_ENDOFSTATS), me.name, parv[0], parv[1]);
 
-  if((statchar != 'L') && (statchar != 'l'))
-    stats_spy(source_p, statchar);
+  stats_spy(source_p, statchar);
 }
 
 
@@ -378,109 +365,6 @@
   show_events(source_p);
 }
 
-/* stats_pending_glines()
- *
- * input	- client pointer
- * output	- none
- * side effects - client is shown list of pending glines
- */
-static void
-stats_pending_glines(struct Client *source_p)
-{
-  dlink_node *pending_node;
-  struct gline_pending *glp_ptr;
-  char timebuffer[MAX_DATE_STRING];
-  struct tm *tmptr;
-
-  if(!ConfigFileEntry.glines)
-  {
-    sendto_one(source_p, ":%s NOTICE %s :This server does not support G-Lines",
-               me.name, source_p->name); 
-    return;
-  }
-
-  if (dlink_list_length(&pending_glines) > 0)
-    sendto_one(source_p, ":%s NOTICE %s :Pending G-lines",
-	       me.name, source_p->name);
-
-  DLINK_FOREACH(pending_node, pending_glines.head)
-  {
-    glp_ptr = pending_node->data;
-      
-    tmptr = localtime(&glp_ptr->time_request1);
-    strftime(timebuffer, MAX_DATE_STRING, "%Y/%m/%d %H:%M:%S", tmptr);
-
-    sendto_one(source_p,
-	       ":%s NOTICE %s :1) %s!%s@%s on %s requested gline at %s for %s@%s [%s]",
-	       me.name, source_p->name, glp_ptr->oper_nick1,
-	       glp_ptr->oper_user1, glp_ptr->oper_host1,
-	       glp_ptr->oper_server1, timebuffer,
-	       glp_ptr->user, glp_ptr->host, glp_ptr->reason1);
-
-    if(glp_ptr->oper_nick2[0] != '\0')
-    {
-      tmptr = localtime(&glp_ptr->time_request2);
-      strftime(timebuffer, MAX_DATE_STRING, "%Y/%m/%d %H:%M:%S", tmptr);
-      sendto_one(source_p,
-      ":%s NOTICE %s :2) %s!%s@%s on %s requested gline at %s for %s@%s [%s]",
-		 me.name, source_p->name, glp_ptr->oper_nick2,
-		 glp_ptr->oper_user2, glp_ptr->oper_host2,
-		 glp_ptr->oper_server2, timebuffer,
-		 glp_ptr->user, glp_ptr->host, glp_ptr->reason2);
-    }
-  }
-
-  sendto_one(source_p, ":%s NOTICE %s :End of Pending G-lines",
-	     me.name, source_p->name);
-}
-
-/* stats_glines()
- *
- * input	- client pointer
- * output	- none
- * side effects - client is shown list of glines
- */
-static void
-stats_glines(struct Client *source_p)
-{
-  dlink_node *gline_node;
-  struct ConfItem *kill_ptr;
-  char *host;
-  char *name;
-  char *reason;
-
-  if(!ConfigFileEntry.glines)
-  {
-    sendto_one(source_p, ":%s NOTICE %s :This server does not support G-Lines",
-               me.name, source_p->name); 
-    return;
-  }
-
-  DLINK_FOREACH(gline_node, glines.head)
-  {
-    kill_ptr = gline_node->data;
-
-    if(kill_ptr->host)
-      host = kill_ptr->host;
-    else
-      host = "*";
-
-    if(kill_ptr->name)
-      name = kill_ptr->name;
-    else
-      name = "*";
-
-    if(kill_ptr->passwd)
-      reason = kill_ptr->passwd;
-    else
-      reason = "No Reason";
-    
-    sendto_one(source_p, form_str(RPL_STATSKLINE), me.name,
-	       source_p->name, 'G', host, name, reason);
-  }
-}
-
-
 static void
 stats_hubleaf(struct Client *source_p)
 {
@@ -680,8 +564,6 @@
 
   sendto_one(source_p, ":%s %d %s :%d OPER(s)", me.name, RPL_STATSDEBUG,
              source_p->name, j);
-
-  stats_p_spy(source_p);
 }
 
 static void
@@ -883,7 +765,6 @@
     statchar=parv[1][0];
 
     stats_L(source_p, name, doall, wilds, statchar);
-    stats_L_spy(source_p, statchar, name);
   }
   else
     sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
@@ -978,20 +859,21 @@
 	}
       else
 	{
+
           /* If its a hidden ip, an admin, or a server, mask the real IP */
 	  if(IsIPSpoof(target_p) || IsServer(target_p) || IsAdmin(target_p)
 	     || IsHandshake(target_p) || IsConnecting(target_p))
-	    sendto_one(source_p, Lformat, me.name,
-		       RPL_STATSLINKINFO, source_p->name,
-		       get_client_name(target_p, MASK_IP),
-		       (int)linebuf_len(&target_p->localClient->buf_sendq),
-		       (int)target_p->localClient->sendM,
-		       (int)target_p->localClient->sendK,
-		       (int)target_p->localClient->receiveM,
-		       (int)target_p->localClient->receiveK,
-		       CurrentTime - target_p->firsttime,
-		       (CurrentTime > target_p->since) ? (CurrentTime - target_p->since):0,
-		       IsServer(target_p) ? show_capabilities(target_p) : "-");
+        sendto_one(source_p, Lformat, me.name,
+               RPL_STATSLINKINFO, source_p->name,
+               get_client_name(target_p, MASK_IP),
+               (int)linebuf_len(&target_p->localClient->buf_sendq),
+               (int)target_p->localClient->sendM,
+               (int)target_p->localClient->sendK,
+               (int)target_p->localClient->receiveM,
+               (int)target_p->localClient->receiveK,
+               CurrentTime - target_p->firsttime,
+               (CurrentTime > target_p->since) ? (CurrentTime - target_p->since):0,
+               IsServer(target_p) ? show_capabilities(target_p) : "-");
 	  else /* show the real IP */
 	    sendto_one(source_p, Lformat, me.name,
 		       RPL_STATSLINKINFO, source_p->name,
@@ -1026,53 +908,13 @@
 static void
 stats_spy(struct Client *source_p, char statchar)
 {
-  struct hook_stats_data data;
-
-  data.source_p = source_p;
-  data.statchar = statchar;
-  data.name = NULL;
-
-  hook_call_event("doing_stats", &data);
-}
-
-/* stats_p_spy()
- *
- * input	- pointer to client doing stats
- * ouput	-
- * side effects - call hook doing_stats_p
- */
-static void
-stats_p_spy(struct Client *source_p)
-{
-  struct hook_stats_data data;
-
-  data.source_p = source_p;
-  data.name = NULL;
-  data.statchar = 'p';
-
-  hook_call_event("doing_stats_p", &data);
-}
-
-/* 
- * stats_L_spy
- * 
- * inputs	- pointer to source_p, client doing stats L
- *		- stat that they are doing 'L' 'l'
- * 		- any name argument they have given
- * output	- NONE
- * side effects	- a notice is sent to opers, IF spy mode is configured
- * 		  in the conf file.
- */
-static void
-stats_L_spy(struct Client *source_p, char statchar, char *name)
-{
-  struct hook_stats_data data;
-
-  data.source_p = source_p;
-  data.statchar = statchar;
-  data.name = name;
-
-  hook_call_event("doing_stats", &data);
+  sendto_realops_flags(FLAGS_SPY, L_ALL,
+		       "STATS %c requested by %s (%s@%s) [%s]",
+      		   statchar,
+			   source_p->name,
+			   source_p->username,
+               source_p->host,
+			   source_p->user->server);
 }
 
 /*
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_svscmds.c ircd-hybrid-fuis/modules/m_svscmds.c
--- ircd-hybrid-7.0rc9/modules/m_svscmds.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-fuis/modules/m_svscmds.c	Sat Mar 22 18:55:33 2003
@@ -0,0 +1,474 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, m_svscmds.c
+ *   Copyright (C) 2002 NeoIRCd Development Team
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svscmds.c,v 1.9 2002/10/31 13:01:56 fishwaldo + FUIS Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "common.h"
+#include "ircd.h"
+#include "irc_string.h"
+#include "numeric.h"
+#include "fdlist.h"
+#include "s_bsd.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "hash.h"
+#include "whowas.h"
+
+#define NS_NICK "NS"
+
+static void ms_svsnick(struct Client *client_p, struct Client *source_p,
+					   int parc, char *parv[]);
+static void ms_svsjoin(struct Client *client_p, struct Client *source_p,
+                       int parc, char *parv[]);
+static void ms_svspart(struct Client *client_p, struct Client *source_p,
+		               int parc, char *parv[]);
+static void ms_svsmode(struct Client *client_p, struct Client *source_p,
+		               int parc, char *parv[]);
+static void m_netname(struct Client *client_p, struct Client *source_p,
+		              int parc, char *parv[]);
+static void m_identify(struct Client *client_p, struct Client *source_p,
+		              int parc, char *parv[]);
+static int clean_nick_name(char *);
+
+struct Message netname_msgtab = {
+  "NETNAME", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_ignore, m_netname, m_netname, m_netname}
+};
+
+struct Message identify_msgtab = {
+  "IDENTIFY", 0, 0, 2, 1, MFLG_SLOW, 0,
+  {m_ignore, m_identify, m_identify, m_identify}
+};
+
+struct Message svsnick_msgtab = {
+  "SVSNICK", 0, 0, 4, 4, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_svsnick, m_ignore}
+};
+
+struct Message svsjoin_msgtab = {
+  "SVSJOIN", 0, 0, 3, 0, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_svsjoin, m_ignore}
+};
+
+struct Message svspart_msgtab = {
+  "SVSPART", 0, 0, 3, 0, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_svspart, m_ignore}
+};
+
+struct Message svsmode_msgtab = {
+  "SVSMODE", 0, 0, 3, 0, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_svsmode, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&identify_msgtab);
+  mod_add_cmd(&netname_msgtab);
+  mod_add_cmd(&svsnick_msgtab);
+  mod_add_cmd(&svsjoin_msgtab);
+  mod_add_cmd(&svspart_msgtab);
+  mod_add_cmd(&svsmode_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&identify_msgtab);
+  mod_del_cmd(&netname_msgtab);
+  mod_del_cmd(&svsnick_msgtab);
+  mod_del_cmd(&svsjoin_msgtab);
+  mod_del_cmd(&svspart_msgtab);
+  mod_del_cmd(&svsmode_msgtab);
+}
+
+const char *_version = "$Revision: 1.91 $";
+#endif
+/* m_netname
+ *
+ * Displays the current ServerInfo.network_name
+ *
+ * parv[0] = sender prefix
+ */
+static void m_netname(struct Client *client_p, struct Client *source_p,
+		              int parc, char *parv[])
+{
+  if (!source_p->user)
+	return;
+
+  /* now it's a user requesting the netname give it to him */
+  sendto_one(source_p, ":%s NOTICE %s :The network name is: %s", me.name, source_p->name, ServerInfo.network_name);
+}
+
+/* m_identify
+ *
+ * Identifies you in the NS.
+ *
+ * parv[0] = sender prefix
+ * parv[1] = password
+ */
+static void m_identify(struct Client *client_p, struct Client *source_p,
+		              int parc, char *parv[])
+{
+  struct Client *services_p;
+
+  if (!source_p->user)
+	return;
+
+  if (ServicesOn && (services_p = find_person(NS_NICK)) != NULL)
+	/* now it's a user wanting to identify in NS */
+	sendto_one(services_p, ":%s PRIVMSG %s :identify %s", parv[0], services_p->name, parv[1]);
+  else
+	sendto_one(source_p, ":%s PRIVMSG %s :Services are temporaly down please be patient...", me.name, source_p->name);
+}
+
+/* ms_svsnick
+ *
+ *	Changes the targets nickname
+ * 	parv[0] = sender prefix
+ *	parv[1] = target 
+ *	parv[2] = new nickname
+ *	parv[3] = ts
+ */
+static void ms_svsnick(struct Client *client_p, struct Client *source_p,
+			           int parc, char *parv[])
+{
+  struct Client *target_p;
+
+  target_p = find_person(parv[1]);
+
+  if (target_p == NULL) {
+	ilog(L_WARN, "SVSNICK from %s was invalid. Can't find the client", parv[1]);
+	return;
+  }
+
+  if (!IsClient(target_p)) 
+	return;
+
+  if (!IsServer(source_p)) {
+	sendto_realops_flags(FLAGS_ALL, L_ALL, "Non Server %s is attempting to use svsnick on %s", source_p->name, target_p->name);
+	return;
+  }
+
+  if (MyClient(target_p)) {
+    if (!clean_nick_name(parv[2]) || !irccmp(target_p->name, parv[2])) {
+	  ilog(L_WARN, "SVSNICK: Invalid Nickname");
+	  return;
+	}
+
+	target_p->tsinfo = parv[4] ? atol(parv[3]) : CurrentTime;
+	sendto_common_channels_local(target_p, 1, ":%s!%s@%s NICK :%s", target_p->name, target_p->username, target_p->host, parv[2]);
+
+	if (target_p->user) {
+	  add_history(target_p, 1);
+	  sendto_server(NULL, target_p, NULL, 0, 0, LL_ICLIENT, ":%s NICK %s :%lu", target_p->name, parv[2], target_p->tsinfo);
+	}	
+
+	if (target_p->name[0])
+	  del_from_client_hash_table(target_p->name, target_p);
+
+	strcpy(target_p->name, parv[2]);
+	add_to_client_hash_table(target_p->name, target_p);
+
+	del_all_accepts(target_p);
+  } else {
+	/* just relay the svsnick to a server that has this client */
+	sendto_one(target_p, ":%s SVSNICK %s %s :%lu", source_p->name, target_p->name, parv[2], atol(parv[3]));
+  }
+  return;
+}
+
+/* clean_nick_name()
+ *
+ * input	- nickname
+ * output	- none
+ * side effects - walks through the nickname, returning 0 if erroneous
+ */
+static int clean_nick_name(char *nick)
+{
+  assert(nick);
+  if (nick == NULL)
+	return 0;
+
+  if (*nick == '-' || IsDigit(*nick))
+    return 0;
+
+  for(; *nick; nick++)
+  {
+    if(!IsNickChar(*nick))
+      return 0;
+  }
+
+  return 1;
+}
+
+/* ms_svsjoin
+ *
+ *  parv[0] = sender prefix
+ *  parv[1] = user to force
+ *  parv[2] = channel to force them into
+ *	parv[3] = key
+ */
+static void ms_svsjoin(struct Client *client_p, struct Client *source_p,
+                         int parc, char *parv[])
+{
+  struct Client *target_p;
+  struct Channel *chptr;
+  int type;
+  char mode;
+  char sjmode;
+  char *newch;
+
+  if (!IsServer(source_p)) {
+	sendto_realops_flags(FLAGS_ALL, L_ALL, "Non Server %s is attempting to use svsjoin", source_p->name);
+	return;
+  }
+
+  if ((hunt_server(client_p, source_p, ":%s SVSJOIN %s %s", 1, parc, parv)) != HUNTED_ISME)
+    return;
+
+  if ((target_p = find_client(parv[1])) == NULL)
+  {
+    if (IsClient(source_p))
+	  sendto_one(source_p, form_str(ERR_NOSUCHNICK),
+				 me.name, source_p->name, parv[1]);
+    return;
+  }
+
+  if(!IsClient(target_p))
+    return;
+
+  if (parv[2][0] == '@')
+  {
+    type = CHFL_CHANOP;
+    mode = 'o';
+    sjmode = '@';
+  }
+  else if (parv[2][0] == '%')
+  {
+    type = CHFL_HALFOP;
+    mode = 'h';
+    sjmode = '%';
+  }
+  else if (parv[2][0] == '+')
+  {
+    type = CHFL_VOICE;
+    mode = 'v';
+    sjmode = '+';
+  }
+  else
+  {
+    type = CHFL_PEON;
+    mode = sjmode = '\0';
+  }
+    
+  if (mode != '\0')
+    parv[2]++;
+    
+  if ((chptr = hash_find_channel(parv[2])) != NULL)
+  {
+    if (IsMember(target_p, chptr))
+    {
+         return;
+    }
+    if (!BadPtr(chptr->mode.key) && irccmp(chptr->mode.key, parc >= 4 ? parv[3] : "") && !IsOper(target_p))
+	{
+	  sendto_one(target_p, ":%s NOTICE %s :*** Notice -- You've messed up the key brother!",
+			     me.name, target_p->name);
+	  return;
+	}
+
+	if ((chptr->mode.mode & MODE_INVITEONLY) && !IsOper(target_p))
+	{
+	  sendto_one(target_p, ":%s NOTICE %s :*** Notice -- The channel is invite only, and you're not invited to the party!:P",
+				 me.name, target_p->name);
+	  return;
+	}
+
+	if ((chptr->mode.limit) && chptr->users >= chptr->mode.limit && !IsOper(target_p))
+	{
+	  sendto_one(target_p, ":%s NOTICE %s :*** Notice -- There's not enough room for the both of us, esse (channel is full)!",
+			     me.name, target_p->name);
+	  return;
+	}
+
+    add_user_to_channel(chptr, target_p, type);
+
+    if (chptr->chname[0] != '&')
+      sendto_server(NULL, target_p, chptr, NOCAPS, NOCAPS, LL_ICLIENT,
+	  			    ":%s SJOIN %lu %s + :%c%s",
+	          		me.name, (unsigned long) chptr->channelts,
+	          		chptr->chname, type ? sjmode : ' ', target_p->name);
+
+	sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+                           target_p->name, target_p->username,
+                           target_p->host, chptr->chname);
+
+    if (type)
+  	  sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s +%c %s",
+	                    	 me.name, chptr->chname, mode, target_p->name);
+        
+    if (chptr->topic != NULL)
+    {
+	  sendto_one(target_p, form_str(RPL_TOPIC), me.name,
+	  		     target_p->name, chptr->chname, chptr->topic);
+      sendto_one(target_p, form_str(RPL_TOPICWHOTIME),
+	        	 me.name, source_p->name, chptr->chname,
+	          	 chptr->topic_info, chptr->topic_time);
+    }
+
+    channel_member_names(target_p, chptr, chptr->chname, 1);
+  }
+  else
+  {
+    newch = parv[2];
+    if (!check_channel_name(newch))
+    {
+      if (IsClient(source_p))
+	    sendto_one(source_p, form_str(ERR_BADCHANNAME), me.name, source_p->name, (unsigned char*)newch);
+	  return;
+	}
+
+    if (!IsChannelName(newch))
+    {
+      if (IsClient(source_p))
+		sendto_one(source_p, form_str(ERR_BADCHANNAME), me.name, source_p->name, (unsigned char*)newch);
+      return;
+    }
+
+    if (ConfigServerHide.disable_local_channels && (*newch == '&'))
+    {
+      if (IsClient(source_p))
+	    sendto_one(source_p, ":%s NOTICE %s :No such channel (%s)", me.name, source_p->name, newch);
+      return;
+    }
+
+    if (strlen(newch) > CHANNELLEN)
+    {
+	  if (IsClient(source_p))
+	    sendto_one(source_p, ":%s NOTICE %s :Channel name is too long", me.name, source_p->name);
+      return;
+    }
+
+    chptr = get_or_create_channel(target_p, newch, NULL);
+    add_user_to_channel(chptr, target_p, CHFL_CHANOP);
+
+    if (chptr->chname[0] != '&')
+      sendto_server(NULL, target_p, chptr, NOCAPS, NOCAPS, LL_ICLIENT,
+                    ":%s SJOIN %lu %s +nt :!%s", me.name,
+				    (unsigned long) chptr->channelts, chptr->chname,
+		    	    target_p->name);
+
+    sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+                         target_p->name, target_p->username,
+                         target_p->host, chptr->chname);
+
+    chptr->mode.mode |= MODE_TOPICLIMIT;
+    chptr->mode.mode |= MODE_NOPRIVMSGS;
+
+    sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s +nt", me.name,
+                         chptr->chname);
+
+    target_p->localClient->last_join_time = CurrentTime;
+    channel_member_names(target_p, chptr, chptr->chname, 1);
+  }
+}
+
+/* ms_svspart
+ *
+ * parv[0] - sender
+ * parv[1] - nickname
+ * parv[2] - channel to part from
+ */
+static void ms_svspart(struct Client *client_p, struct Client *source_p,
+		               int parc, char *parv[])
+{
+  struct Client *target_p;
+  struct Channel *chptr;
+
+  if (!IsServer(source_p))
+    return;
+
+  if ((hunt_server(client_p, source_p, ":%s SVSPART %s %s", 1, parc, parv)) != HUNTED_ISME)
+    return;
+
+  if ((target_p = find_client(parv[1])) == NULL)
+  {
+    if (IsClient(source_p))
+	  sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, source_p->name, parv[1]);
+    return;
+  }
+
+  if (!IsClient(target_p))
+    return;
+
+  if ((chptr = hash_find_channel(parv[2])) == NULL)
+  {
+    if (IsClient(source_p))
+	  sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL), me.name, parv[0], parv[1]);
+    return;
+  }
+
+  if (!IsMember(target_p, chptr))
+  {
+    if (IsClient(source_p))
+	  sendto_one(source_p, form_str(ERR_USERNOTINCHANNEL), me.name, parv[0], parv[2], parv[1]);
+    return;
+  }
+  
+  if (chptr->chname[0] != '&')
+    sendto_server(target_p, target_p, chptr, NOCAPS, NOCAPS, LL_ICLIENT,
+			      ":%s PART %s :%s",
+		  		  target_p->name, chptr->chname,
+				  target_p->name);
+
+  sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s PART %s :%s",
+                       target_p->name, target_p->username,
+	   	               target_p->host, chptr->chname,
+				       target_p->name);
+
+  remove_user_from_channel(chptr, target_p);
+}
+
+/* ms_svsmode
+ *
+ * parv[0] - sender
+ * parv[1] - username to change mode for
+ * parv[2] - modes to change
+ */
+static void ms_svsmode(struct Client *client_p, struct Client *source_p,
+                       int parc, char *parv[])
+{
+  if (!IsServer(source_p))
+	return;
+
+  user_mode(client_p, source_p, parc, parv);
+}
